function out=ibp( in,inup,tol,max_ite )
% out=ibp( in,inup,[tol],[max_ite] )

if nargin < 3 ,
  tol=1e-8;
end
if nargin < 4 ,
  max_ite=50;
end

out=inup;
for ite=1:max_ite ,
  r=imresize( in-imresize( out,[size(in,1),size(in,2)] ),[size(out,1),size(out,2)]);
  out(:)=out(:)+r(:);
  rr=(r(:)'*r(:))./(out(:)'*out(:));
%   fprintf( '%02d\t\t%5.4e\n',ite,rr );
  if rr < tol ,
    break;
  end
end

end
